
Redmine - Patch #26655

Additional icon for contextmenu

2017-08-09 12:03 - Felix Gliesche

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 4.0.0   

Description

The contextmenu is a very helpful feature that can increase the productivity while working with redmine. Many people don't know of

this great feature because it is only triggered by a right mouse click, which is not a common user interaction on the web. In order to

make this feature more prominent this patch adds an icon to table rows that have a contextmenu, which allows to trigger the

appearance of the contextmenu with a regular mouse click.

As there was no icon with three dots available in the famfamfam available, we created our own by using an existing icon with a dot.

This gif shows this new icon in action on the issues table:

 contextmenu.gif 

Related issues:

Related to Redmine - Feature #5711: Make Bulk Edit menu more apparent... New 2010-06-18

Related to Redmine - Feature #28829: Add right-click context menu to the cont... Reopened

Has duplicate Redmine - Feature #1590: Awkward way of accessing shortcut menu... Closed 2008-07-06

Has duplicate Redmine - Defect #5739: Direct access to Issue update from issu... Closed 2010-06-23

Has duplicate Redmine - Feature #29074: Add "Edit" function to entries in "Sp... Closed

Associated revisions

Revision 17252 - 2018-04-02 03:42 - Go MAEDA

Use button as additional option for contextmenu (#26655).

Patch by Felix Gliesche.

Revision 17253 - 2018-04-02 03:46 - Go MAEDA

Add button_actions string to locales (#26655).

Revision 17254 - 2018-04-02 04:24 - Go MAEDA

Reverted r17252 and r17253 (#26655).

The change breaks the test suite.

Revision 17298 - 2018-04-21 14:00 - Go MAEDA

Use button as additional option for contextmenu (#26655).

Patch by Felix Gliesche.

Revision 17302 - 2018-04-21 16:46 - Go MAEDA

Add button_actions string to locales (#26655).

History

#1 - 2017-08-09 12:12 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#2 - 2017-08-09 12:13 - Jan from Planio www.plan.io

- File deleted (contextmenu.gif)
#3 - 2017-08-09 12:38 - Felix Gliesche

- File contextmenu.gif added

#4 - 2017-08-09 12:39 - Jan from Planio www.plan.io

- Tracker changed from Defect to Patch

#5 - 2017-08-09 15:27 - Go MAEDA

+1

Felix Gliesche wrote:

Many people don't know of this great feature because it is only triggered by a right mouse click, which is not a common user interaction on the

web.

 I think it is exactly right. It is very good idea to make the context menu obvious.

#6 - 2017-08-09 15:48 - Luis Blasco

You're absolutely right. Context menu is not used, too "hidden". This is a very good solution.

#7 - 2017-08-09 15:55 - Jan from Planio www.plan.io

The patch is based on user research we did for Planio Redmine Hosting. We also surveyed a number of other platforms which use item list

representations and context menus (Dropbox, Nextcloud, box.net, etc.). A horizontal three dotted icon seems by far to be the most common trigger for

a context menu these days. Right click without alternative was only present in a few examples (e.g. Google Drive). The feature will be rolling out at

Planio soon and I would love for this to become part of Redmine as well!

#8 - 2017-08-10 02:06 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.1.0

The icon greatly improves usability.

Setting target version to 4.1.0.

#9 - 2017-08-14 22:01 - Marius BĂLTEANU

- File vertical.png added

Very nice feature, especially that it will make the context menu available on the mobile.

It looks good also with a vertical three dotted icon.

 vertical.png 

#10 - 2017-08-14 22:17 - Felix Schäfer

Marius BALTEANU wrote:

It looks good also with a vertical three dotted icon.

 This would be confusing as the vertical dots are already used as drag and drop handlers for trackers, enumerations, statuses and so on.

#11 - 2017-08-14 22:33 - Marius BĂLTEANU

Felix Schäfer wrote:

Marius BALTEANU wrote:

It looks good also with a vertical three dotted icon.

 This would be confusing as the vertical dots are already used as drag and drop handlers for trackers, enumerations, statuses and so on.

 From my knowledge, the drag and drop handlers have a green arrow as icon. Anyway, it is not so important how the dots are displayed, both options

look good to me and also, the dots can be easily rotated only from CSS. I just wanted to point out this alternative.

#12 - 2017-08-14 22:51 - Felix Schäfer

Marius BALTEANU wrote:
From my knowledge, the drag and drop handlers have a green arrow as icon.

 You are right, I am sorry, the 3 dots are used in a theme, and vertical dots are used as drag and drop handlers in Gmail for example too.

#13 - 2017-08-15 14:03 - Felix Gliesche

- File 0001-Use-button-as-additional-option-for-contextmenu.patch added

I am attaching an updated patch, that sets correct colspan when grouping issue lists.

#14 - 2017-08-15 14:08 - Jan from Planio www.plan.io

- File deleted (0001-Use-button-as-additional-option-for-contextmenu.patch)

#15 - 2017-08-16 02:55 - Go MAEDA

- File mastodon-context-menu-button@2x.png added

FYI:

Mastodon (social network server) uses horizontal three dots button for context menu.

 

#16 - 2017-08-24 13:19 - Toshi MARUYAMA

- Description updated

#17 - 2017-10-15 10:00 - Go MAEDA

- Has duplicate Feature #1590: Awkward way of accessing shortcut menu in issue list added

#18 - 2017-11-08 05:54 - Mischa The Evil

- Related to Feature #5711: Make Bulk Edit menu more apparent... added

#19 - 2018-01-28 02:39 - Go MAEDA

- File 26555-list_html_erb-for-r16971.diff added

- File 3_bullets.png added

I made a slight change to the patch because I couldn't apply to the current trunk (r16971 and later).

And the patch doesn't include 3_bullets.png, so I stole the icon from Planio :)

#20 - 2018-01-28 05:33 - Go MAEDA

- File icon-for-subtasks@2x.png added

- Status changed from New to Needs feedback

I found a small problem that the context menu icon is displayed in a wrong position for subtasks. No problem for related issues. I also confirmed the

very similar problem in my Planio account.

Felix Gliesche, could you fix this?
#21 - 2018-01-29 15:46 - Felix Gliesche

Go MAEDA wrote:

I found a small problem that the context menu icon is displayed in a wrong position for subtasks. No problem for related issues. I also confirmed

the very similar problem in my Planio account.

Felix Gliesche, could you fix this?

 Sure, I'll have a look into it.

#22 - 2018-01-30 10:59 - Felix Gliesche

- File 0001-Use-button-as-additional-option-for-contextmenu.patch added

I am uploading a patch, that should apply to the current trunk. The problem, you are referencing to is related to missing mobile optimiziation. I added

missing styles to public/stylesheets/responsive.css  as you can see in the updated version of the patch.

#23 - 2018-01-30 13:38 - Felix Gliesche

- File 0001-Use-button-as-additional-option-for-contextmenu.patch added

I had to update the patch (see attached). Could you please delete the previous one, to avoid confusion?

#24 - 2018-01-30 13:46 - Felix Gliesche

- File 0001-Use-button-as-additional-option-for-contextmenu.patch added

I found, that the text shines through, due to right padding, which is not necessary on mobile devices. I removed this, whit this updated patch. Please

use this one ;)

#25 - 2018-01-30 14:47 - Marius BĂLTEANU

- File deleted (0001-Use-button-as-additional-option-for-contextmenu.patch)

#26 - 2018-01-30 14:47 - Marius BĂLTEANU

- File deleted (0001-Use-button-as-additional-option-for-contextmenu.patch)

#27 - 2018-01-30 14:47 - Marius BĂLTEANU

- File deleted (0001-Use-button-as-additional-option-for-contextmenu.patch)

#28 - 2018-01-31 03:54 - Go MAEDA

- Status changed from Needs feedback to New

Thank you for updating the patch. Now it works perfectly. I think this feature should be a part of Redmine 4.0 / 4.1.
#29 - 2018-04-02 03:47 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

Committed. Thank you for sharing this great improvement.

#30 - 2018-04-02 04:23 - Go MAEDA

- Status changed from Closed to Reopened

- Assignee deleted (Go MAEDA)

- Target version changed from 4.0.0 to 4.1.0

Reverted r17252 and r17253 because the patch breaks the test suite.

#31 - 2018-04-13 10:00 - Go MAEDA

- Assignee set to Felix Gliesche

After applying the patch, an exception is raised if a user who does not have "Manage related issues" permission opens an issue with one or more

related issues. You can also confirm the problem by running test/functional/issues_controller_test.rb.

But I noticed that this bug has already fixed in Planio. Could you kindly provide a patch based on the current Planio's code base?

#32 - 2018-04-13 10:03 - Felix Gliesche

Go MAEDA wrote:

After applying the patch, an exception is raised if a user who does not have "Manage related issues" permission opens an issue with one or

more related issues. You can also confirm the problem by running test/functional/issues_controller_test.rb.

But I noticed that this bug has already fixed in Planio. Could you kindly provide a patch based on the current Planio's code base?

 Sure, I will have a look into it. Already working on the patch, so that it does not break the test suite.

#33 - 2018-04-19 16:06 - Felix Gliesche

- File 0001-Use-button-as-additional-option-for-contextmenu.patch added

Go MAEDA wrote:

Committed. Thank you for sharing this great improvement.

 I am uploading the updated patch. It does not break the test suite and fixes the problem for users without the "manage related issues" permission that

you mentioned.

#34 - 2018-04-21 07:58 - Jan from Planio www.plan.io

- File deleted (0001-Use-button-as-additional-option-for-contextmenu.patch)

#35 - 2018-04-21 14:03 - Go MAEDA

- Status changed from Reopened to Resolved

Committed. Thank you so much for updating the patch.

#36 - 2018-04-21 16:45 - Go MAEDA

- Status changed from Resolved to Closed

#37 - 2018-04-22 07:13 - Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

#38 - 2018-04-23 15:25 - Go MAEDA

- Assignee changed from Felix Gliesche to Go MAEDA
#39 - 2018-05-21 15:58 - Go MAEDA

- Related to Feature #28829: Add right-click context menu to the contextual area of an issue added

#40 - 2018-06-09 04:00 - Go MAEDA

- Has duplicate Defect #5739: Direct access to Issue update from issue list added

#41 - 2018-06-20 18:46 - Marius BĂLTEANU

- Has duplicate Feature #29074: Add "Edit" function to entries in "Spent Time" block appropriately added

Files

contextmenu.gif 71.4 KB 2017-08-09 Felix Gliesche

vertical.png 109 KB 2017-08-14 Marius BĂLTEANU

mastodon-context-menu-button@2x.png 35.8 KB 2017-08-16 Go MAEDA

26555-list_html_erb-for-r16971.diff 1.55 KB 2018-01-28 Go MAEDA

3_bullets.png 1.22 KB 2018-01-28 Go MAEDA

icon-for-subtasks@2x.png 18 KB 2018-01-28 Go MAEDA

0001-Use-button-as-additional-option-for-contextmenu.patch 18.9 KB 2018-04-19 Felix Gliesche
